package xyz.zhouxy.plusone.constant;

import java.util.Collection;

import javax.annotation.Nonnull;

import xyz.zhouxy.plusone.commons.util.Enumeration;

/**
 * 实体状态
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 */
public final class EntityStatus extends Enumeration<EntityStatus> {

    private EntityStatus(int id, @Nonnull String name) {
        super(id, name);
    }

    // 常量
    public static final EntityStatus AVAILABLE = new EntityStatus(0, "正常");
    public static final EntityStatus DISABLED = new EntityStatus(1, "禁用");

    private static final ValueSet<EntityStatus> VALUE_SET = ValueSet.of(AVAILABLE, DISABLED);

    public static EntityStatus of(int id) {
        return VALUE_SET.get(id);
    }

    public static Collection<EntityStatus> constants() {
        return VALUE_SET.getValues();
    }
}
