package xyz.zhouxy.plusone.oss;

import java.util.List;

import org.springframework.boot.context.properties.ConfigurationProperties;

@ConfigurationProperties("fastdfs")
public class FastDFSProperties {
    private Integer connectTimeoutInSeconds;
    private Integer networkTimeoutInSeconds;
    private String charset;
    private Boolean httpAntiStealToken;
    private String httpSecretKey;
    private Integer httpTrackerHttpPort;
    private List<String> trackerServers;

    private ConnectionPool connectionPool;

    public Integer getConnectTimeoutInSeconds() {
        return connectTimeoutInSeconds;
    }

    public void setConnectTimeoutInSeconds(Integer connectTimeoutInSeconds) {
        this.connectTimeoutInSeconds = connectTimeoutInSeconds;
    }

    public Integer getNetworkTimeoutInSeconds() {
        return networkTimeoutInSeconds;
    }

    public void setNetworkTimeoutInSeconds(Integer networkTimeoutInSeconds) {
        this.networkTimeoutInSeconds = networkTimeoutInSeconds;
    }

    public String getCharset() {
        return charset;
    }

    public void setCharset(String charset) {
        this.charset = charset;
    }

    public Boolean getHttpAntiStealToken() {
        return httpAntiStealToken;
    }

    public void setHttpAntiStealToken(Boolean httpAntiStealToken) {
        this.httpAntiStealToken = httpAntiStealToken;
    }

    public String getHttpSecretKey() {
        return httpSecretKey;
    }

    public void setHttpSecretKey(String httpSecretKey) {
        this.httpSecretKey = httpSecretKey;
    }

    public Integer getHttpTrackerHttpPort() {
        return httpTrackerHttpPort;
    }

    public void setHttpTrackerHttpPort(Integer httpTrackerHttpPort) {
        this.httpTrackerHttpPort = httpTrackerHttpPort;
    }

    public List<String> getTrackerServers() {
        return trackerServers;
    }

    public void setTrackerServers(List<String> trackerServers) {
        this.trackerServers = trackerServers;
    }

    public ConnectionPool getConnectionPool() {
        return connectionPool;
    }

    public void setConnectionPool(ConnectionPool connectionPool) {
        this.connectionPool = connectionPool;
    }

    public static class ConnectionPool {
        private Boolean enabled;
        private Integer maxCountPerEntry;
        private Integer maxIdleTime;
        private Integer maxWaitTimeInMs;

        public Boolean getEnabled() {
            return enabled;
        }

        public void setEnabled(Boolean enabled) {
            this.enabled = enabled;
        }

        public Integer getMaxCountPerEntry() {
            return maxCountPerEntry;
        }

        public void setMaxCountPerEntry(Integer maxCountPerEntry) {
            this.maxCountPerEntry = maxCountPerEntry;
        }

        public Integer getMaxIdleTime() {
            return maxIdleTime;
        }

        public void setMaxIdleTime(Integer maxIdleTime) {
            this.maxIdleTime = maxIdleTime;
        }

        public Integer getMaxWaitTimeInMs() {
            return maxWaitTimeInMs;
        }

        public void setMaxWaitTimeInMs(Integer maxWaitTimeInMs) {
            this.maxWaitTimeInMs = maxWaitTimeInMs;
        }
    }
}
