package xyz.zhouxy.plusone.system.domain.model.account;

import java.util.Collection;

import javax.annotation.Nonnull;

import lombok.Getter;
import xyz.zhouxy.plusone.commons.util.Enumeration;
import xyz.zhouxy.plusone.domain.IValueObject;

/**
 * 账号状态
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 */
@Getter
public final class AccountStatus extends Enumeration<AccountStatus> implements IValueObject {

    private AccountStatus(int id, @Nonnull String name) {
        super(id, name);
    }

    public static final AccountStatus AVAILABLE = new AccountStatus(0, "账号正常");
    public static final AccountStatus LOCKED = new AccountStatus(1, "账号被锁定");

    private static final ValueSet<AccountStatus> VALUE_SET = ValueSet.of(
            AVAILABLE,
            LOCKED);

    public static AccountStatus of(int id) {
        return VALUE_SET.get(id);
    }

    public static Collection<AccountStatus> constants() {
        return VALUE_SET.getValues();
    }
}
