package xyz.zhouxy.plusone.system.domain.model.account;

import java.util.Collection;

import javax.annotation.Nonnull;

import xyz.zhouxy.plusone.commons.annotation.StaticFactoryMethod;
import xyz.zhouxy.plusone.commons.util.Enumeration;
import xyz.zhouxy.plusone.domain.IValueObject;

/**
 * 值对象：性别
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 */
public final class Sex extends Enumeration<Sex> implements IValueObject {
    @Nonnull
    public static final Sex UNSET = new Sex(0, "未设置");
    @Nonnull
    public static final Sex MALE = new Sex(1, "男性");
    @Nonnull
    public static final Sex FEMALE = new Sex(2, "女性");

    private Sex(int id, @Nonnull String name) {
        super(id, name);
    }

    private static final ValueSet<Sex> VALUE_SET = ValueSet.of(UNSET, MALE, FEMALE);

    @StaticFactoryMethod(Sex.class)
    public static Sex of(int value) {
        return VALUE_SET.get(value);
    }

    public static Collection<Sex> constants() {
        return VALUE_SET.getValues();
    }
}
